summaryrefslogtreecommitdiffstats
path: root/doc
diff options
context:
space:
mode:
authorAdrien Beudin <beudbeud@beudibox.fr>2013-02-20 14:59:09 +0100
committerAdrien Beudin <beudbeud@beudibox.fr>2013-02-20 14:59:09 +0100
commitf0461b63c3de00f52c36d21dce7f3605e55cf327 (patch)
tree469094fee97abb0b09677bda43973a2d28a8e4fe /doc
parentb23e626ba638e7fd87c00a01f407fbc26b0a5a67 (diff)
update init script
Diffstat (limited to 'doc')
-rw-r--r--doc/init_script162
1 files changed, 57 insertions, 105 deletions
diff --git a/doc/init_script b/doc/init_script
index d87da9ba..5ba694c1 100644
--- a/doc/init_script
+++ b/doc/init_script
@@ -1,20 +1,22 @@
#! /bin/sh
### BEGIN INIT INFO
-# Provides: radicale
-# Required-Start: $local_fs $remote_fs $network $syslog $named
-# Required-Stop: $local_fs $remote_fs $network $syslog $named
+# Provides: glances
+# Required-Start: networking
+# Required-Stop: networking
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
-# Short-Description: Start and stop the Radicale CalDAV server
+# Short-Description: Start and stop the Glance server
### END INIT INFO
-# Author: nicolas.boos@wanadoo.fr
+# Author: beudbeud@beudibox.fr
+
+set -e
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
-DESC="Radicale CalDAV server"
-NAME=radicale
-DAEMON=/usr/local/bin/$NAME
+DESC="Glances server"
+NAME=glances
+DAEMON=/usr/bin/$NAME
DAEMON_ARGS=""
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
@@ -28,112 +30,62 @@ SCRIPTNAME=/etc/init.d/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
-VERBOSE=yes
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
- # Return
- # 0 if daemon has been started
- # 1 if daemon was already running
- # 2 if daemon could not be started
- start-stop-daemon --start --quiet --background --exec $DAEMON --test > /dev/null || return 1
- start-stop-daemon --start --quiet --background --exec $DAEMON -- $DAEMON_ARGS || return 2
- # Add code here, if necessary, that waits for the process to be ready
- # to handle requests from services started subsequently which depend
- # on this one. As a last resort, sleep for some time.
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
- # Return
- # 0 if daemon has been stopped
- # 1 if daemon was already stopped
- # 2 if daemon could not be stopped
- # other if a failure occurred
- start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
- RETVAL="$?"
- [ "$RETVAL" = 2 ] && return 2
- # Wait for children to finish too if this is a daemon that forks
- # and if the daemon is only ever run from this initscript.
- # If the above conditions are not satisfied then add some other code
- # that waits for the process to drop all resources that could be
- # needed by services started subsequently. A last resort is to
- # sleep for some time.
- start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --pidfile $PIDFILE --exec $DAEMON
- [ "$?" = 2 ] && return 2
- # Many daemons don't delete their pidfiles when they exit.
- rm -f $PIDFILE
- return "$RETVAL"
-}
-
-#
-# Function that sends a SIGHUP to the daemon/service
-#
-do_reload() {
- #
- # If the daemon can reload its configuration without
- # restarting (for example, when it is sent a SIGHUP),
- # then implement that here.
- #
- start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
- return 0
-}
+case $1 in
+ start)
+ if [ -e $PIDFILE ]; then
+ log_daemon_msg "$NAME process was already running"
+ log_end_msg 1
+ else
+ # Start the daemon.
+ log_daemon_msg "Starting the process" "$NAME"
+ # Start the daemon with the help of start-stop-daemon
+ # Log the message appropriately
+ if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE -b -m --exec $DAEMON -- $DAEMON_ARGS; then
+ log_end_msg 0
+ else
+ log_end_msg 1
+ fi
+ fi
+ ;;
-case "$1" in
- start)
- [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
- do_start
- case "$?" in
- 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
- 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
- esac
+ stop)
+ # Stop the daemon.
+ if [ -e $PIDFILE ]; then
+ status_of_proc -p $PIDFILE $DAEMON "Stoppping the $NAME process" && status="0" || status="$?"
+ if [ "$status" = 0 ]; then
+ start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE
+ /bin/rm -rf $PIDFILE
+ fi
+ else
+ log_daemon_msg "Glances process was already stopped"
+ log_end_msg 1
+ fi
;;
- stop)
- [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
- do_stop
- case "$?" in
- 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
- 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
- esac
+
+ restart|reload)
+ # Restart the daemon.
+ $0 stop && sleep 2 && $0 start
;;
- status)
- status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
- ;;
- restart|force-reload)
- #
- # If the "reload" option is implemented then remove the
- # 'force-reload' alias
- #
- log_daemon_msg "Restarting $DESC" "$NAME"
- do_stop
- case "$?" in
- 0|1)
- do_start
- case "$?" in
- 0) log_end_msg 0 ;;
- 1) log_end_msg 1 ;; # Old process is still running
- *) log_end_msg 1 ;; # Failed to start
- esac
- ;;
- *)
- # Failed to stop
+
+ status)
+ # Check the status of the process.
+ if [ -e $PIDFILE ]; then
+ status_of_proc -p $PIDFILE $DAEMON "$NAME process" && exit 0 || exit $?
+ else
+ log_daemon_msg "Glances process is not running"
log_end_msg 1
- ;;
- esac
- ;;
- *)
- echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
- exit 3
+ fi
;;
+
+ *)
+ # For invalid arguments, print the usage message.
+ echo "Usage: $0 {start|stop|restart|reload|status}"
+ exit 2
+ ;;
esac